@**************************************************************************
This procedure integrates f(x)*exp(-x^2)dx from
                    minus infinity to plus infinity
                  using Gauss-Hermite quadrature

Necesary inputs:

 Before calling to the procedure, you must have obtained obtained the nodes
and weights. It can be done by calling the procudure {nodes,weights}=hermite(n),
where n = number of nodes.

proc inthermi(&f,nodes,weighs)

&f=A pointer to a procedure that computes f(x). Notice, the exponential is
excluded. The procedure should be able to deal with matrices. Specifically, the
procedure hermii will pass to f(x) a row vector for each row of x. Therefore, th
e procedure f(x) should give a row for each row of x.


************************************************************************* @

proc inthermi(&f,nodes,weights);
local f:proc;
local pnodes,ff;

pnodes=nodes';
ff=f(pnodes);
retp(ff*weights);
endp;
